# Универсальный установочник "ИУС ЦИФРА" и её компонентов.

# ОБЯЗАТЕЛЬНО К ПРОЧТЕНИЮ ПЕРЕД УСТАНОВКОЙ!

## Поддерживаемые ОС:

1. Ubuntu 18.04-22.04
2. RedOs 7.3
3. Astra Linux (Orel)
4. ALT Linux 10.1

## Предварительные требования:

1. На ОС должен быть создан пользователь с неким именем, имеющий права на запуск комманд через ``sudo``. Если у пользователя при запуске скрипта не будет хватать прав на создание директорий, то установки не произойдет.

2. На ОС должен быть предварительно установлено ПО docker, и созданый ранее пользователь должен иметь права на исполнение docker команд (т.е находится в группе docker). Если ПО не будет установлено заранее, при запуске скрипт попытается установить его самостоятельно и выдать необходимые разрешения, однако идеальным варинатом все равно остается ручная предварительная установка. Инструкции описаны для каждого дистрибутива на соответствующей странице руководства:

- [x] UBUNTU: https://docs.docker.com/engine/install/ubuntu/
- [x] REDOS: https://redos.red-soft.ru/base/arm/arm-other/docker-install/
- [x] ATL: https://www.altlinux.org/Docker
- [x] ASTRA: https://wiki.astralinux.ru/pages/viewpage.action?pageId=158601444

3. Сервер на момент установки должен иметь прямой доступ к интернету. Это связано с тем, что основные файлы выкачиваются из репозиториев по сети.

4. `ОБЯЗАТЕЛЬНО` для доступа к приватным репозиториям ГМИ необходимо сообщить кому-то из админов ПО ЦОД ГМИ свой внешний ip, с которого будет производится подключение - Ковалев Н.С, Мартнынов П.А, Широков О.Ю, Самаркин А.М. Это необходимо, чтобы мы разрешили подключение на своей стороне. Узнать внешний ip можно быстрой командой - `curl eth0.me`. Если доступ не будет выдан, то установки не произойдет.

## Установка:

### Скачиваем архив tar.gz и распаковываем, задав права запуска на install.sh, если они сбились

```shell
tar -xzvf mrgeng-installer.tar.gz
chmod +x install.sh
```

### Конфигурация. Свойства уканазы в settings.conf. Если установка производится НЕ в ЦОД ГМИ, то менять ничего не нужно.

```properties
## Адрес docker репозитория ГМИ
docker_repo=https://docker-repo.mrgeng.ru
repo=https://repo.mrgeng.ru
##Директория установки ЦИФРЫ. При изменении во всех скриптах необходимо менять каталоги бэкапов, запуска и т.д
pathDigit=/opt/mrgeng
##Директория установки SVD. При изменении во всех скриптах необходимо менять каталоги бэкапов, запуска и т.д
pathSVD=/opt/SVD
##Timeout при запросах проверки доступа к ресурсам. При медленном интернете увеличить
curltimeout=7
##Timeout при первоначальном запуске postgres для запуска задач создания БД. Имеет смысл увеличивать на медленных системах
postgresTimeout=10
```

## Установка

### Необходимо производить запуск под текущим пользователем (не root и без sudo). Если скрипт будет выполняться через sudo, то вся инфраструктура установится на root пользователя.

##### В процессе установки потребуется ввести пароль пользователя

```shell

./install.sh {module} {flag}

{module}:

- 'help' - Посмотреть документацию
- 'list' - Выведет актуальный список модулей для установки
- '$module_name' - Имя модуля для установки

{flag}: 

- 'без параметра' - # Просто установит модуль

- '-u' #Обновит скрипты управления и конфигурации системы на уже установленном модуле, данные будут сохранены

- '-f' #Принудительно заного установит модуль, перезапишет скрипты и файлы из исходников. ВСЕ СТАРЫЕ ДАННЫЕ БУДУТ УДАЛЕНЫ!

```

## Обновления

```shell

- updateInstaller.sh # Подтянет последюнюю версию установочника

```

### Базовый каталог ПО - /opt/mrgeng/
### Скрипты запуска, обновления, бэкапов - /opt/mrgeng/bin.
### Порядок запуска: сначала запускаем postgres и cassandra, ждем несколько минут, затем запускам pros.
### Логи - /opt/mrgeng/app/logs, /opt/mrgeng/cassandra/logs, для postgres выполняем 'docker logs postgres'

## Возможные неочевидные баги:

1. На REDOS бывает не стартует Cassandra. Возникает ошибка вида `Local host name unknown: java.net.UnknownHostException`. Это связано с тем, что по умолчанию имя машины не вносится в `/etc/hosts` (Почему так сделано - непонятно), а докер при указании флага --net как раз использует этот файл. Решается очень просто - нужно в этом файле прибить имя машины к 127.0.0.1 и перезапустить контейнер.